#include "access/nbtree.h"
typedef struct
{
	Oid l1;   /* Oid of base index */
	Oid heap;   /* Oid of indexed relation */
	Oid l0;
	uint64 n_inserts; /* Number of performed inserts since database open  */
	Oid     db_id;    /* user ID (for background worker) */
	Oid     user_id;  /* database Id (for background worker) */
	int     top_index_size; /* Size of top index */
} LsmMetaData;

void
index_rebuild(Relation heapRelation,
			Relation indexRelation,
			IndexInfo *indexInfo);

void
lsm_create_l1_if_not_exits(
	Relation heap,
	Relation index,
	LsmMetaData* lsmMetaCopy);
void lsmbuildempty( Relation index);
IndexBuildResult * lsmbuild(Relation heap, Relation index, IndexInfo *indexInfo);

static bool lsm_insert(Relation rel, Datum *values, bool *isnull,
			ItemPointer ht_ctid, Relation heapRel,
			IndexUniqueCheck checkUnique,
			IndexInfo *indexInfo);



#define LSMPageGetMeta(p) \
	((LsmMetaData *)(((BTMetaPageData *) PageGetContents(p))+1))


